texture tex0;

float4x4 ProjectionMatrix; 
float4x4 TextureMatrix; 
float4x4 WorldViewMatrix;
float Alpha;

sampler BaseTexture  =
sampler_state
{
    Texture = <tex0>;
    AddressU = Clamp;
    AddressV = Clamp;
	MipFilter = None;
	MagFilter = Linear;
    MinFilter = Linear;	
};

struct VS_INPUT
{
    float4 vPosition  : POSITION;
};

struct VS_OUTPUT
{
    float4  vPosition : POSITION;
    float3  vTexCoord0 : TEXCOORD0;
};


VS_OUTPUT GeneralVertexShader(const VS_INPUT v )
{
	VS_OUTPUT Out = (VS_OUTPUT)0;

	float4 WorldPos = mul(v.vPosition, WorldViewMatrix);
	Out.vPosition  = mul(WorldPos, ProjectionMatrix );
	Out.vTexCoord0  = mul(v.vPosition, TextureMatrix).xyz;

	return Out;
}


float4 GeneralPixelShader( VS_OUTPUT v ) : COLOR
{
	float4 OutColor = tex2D( BaseTexture, v.vTexCoord0.xy );
	OutColor *= Alpha;
	return OutColor; //Alpha.xxx;
}


technique tec0
{
	pass p0
	{
		//ALPHABLENDENABLE = True;

		VertexShader = compile vs_2_0 GeneralVertexShader();
		PixelShader = compile ps_2_0 GeneralPixelShader();
	}
}
